{Adapted from the C routine of the same name from Press et al., 1992}
procedure lnsrch(n      : integer;
                 xold   : vector;
                 fold   : double;
                 g, p   : vector;
             var x      : vector;
             var f      : double;
                 stpmax : double;
             var check  : boolean);

const
    alf = 1.0e-4;
    tolx = 1.0e-7;

var
   i: integer;
   a,alam,alam2,alamin,b,disc,f2,fold2,
   rhs1,rhs2,slope,sum,temp,test,tmplam: double;

label 1;

begin
    check:= false;
    sum:= 0.0;
    for i:= 1 to n do sum:=sum+p[i]*p[i];
    sum:= sqrt(sum);
    if(sum > stpmax) then begin
      for i:= 1 to n do p[i]:= p[i]*stpmax/sum;
    end;
    slope:= 0.0;
    for i:= 1 to n do slope:= slope+g[i]*p[i];
    test:= 0.0;
    for i:= 1 to n do begin
        temp:= abs(p[i])/max(abs(xold[i]),1.0);
        if(temp > test) then test:= temp;
    end;
    alamin:= TOLX/test;
    alam:= 1.0;
1:  for i:= 1 to n do x[i]:=xold[i]+alam*p[i];
    f:= fmin(x);
    if (alam < alamin) then begin
       for i:= 1 to n do x[i]:= xold[i];
       check:= true;
       exit;
    end
    else
       if (f <= fold+ALF*alam*slope) then exit
    else begin
       if (alam = 1.0) then
          tmplam:= -slope/(2.*(f-fold-slope))
       else begin
          rhs1:= f-fold-alam*slope;
          rhs2:= f2-fold2-alam2*slope;
          a:= (rhs1/(alam*alam)-rhs2/(alam2*alam2))/(alam-alam2);
          b:= (-alam2*rhs1/(alam*alam)+alam*rhs2/(alam2*alam2))/(alam-alam2);
          if (a = 0.0) then
             tmplam:=-slope/(2.0*b)
          else begin
             disc:=b*b-3.0*a*slope;
             tmplam:=(-b+sqrt(disc))/(3.*a);
          end;
          if(tmplam > 0.5*alam) then tmplam:= 0.5*alam;
       end;
    end;
    alam2:= alam;
    f2:= f;
    fold2:= fold;
    alam:= max(tmplam,0.1*alam);
    goto 1
end;
